Bug 83955 - TRACK CHANGES: Customizing the changes toolbar
Summary: TRACK CHANGES: Customizing the changes toolbar
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Writer (show other bugs)
Version:
(earliest affected)
unspecified
Hardware: Other All
: low minor
Assignee: Yousuf Philips (jay)
QA Contact:
URL:
Whiteboard: target:4.4.0 target:4.5.0
Keywords:
Depends on:
Blocks: Track-Changes
  Show dependency treegraph
 
Reported: 2014-09-17 00:14 UTC by Yousuf Philips (jay)
Modified: 2015-03-24 10:15 UTC (History)
9 users (show)

See Also:
Crash report or crash signature:


Attachments
modified changes.xml (1.30 KB, patch)
2014-09-17 00:14 UTC, Yousuf Philips (jay)
Details
modified changes toolbar (11.05 KB, image/png)
2014-09-17 00:18 UTC, Yousuf Philips (jay)
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Yousuf Philips (jay) 2014-09-17 00:14:40 UTC
Created attachment 106396 [details]
modified changes.xml

As a continuation of the work joel made in bug 47677, I would like to further improve on the changes toolbar. Below are the steps i took in order to achieve the final customization results.

Step 1: Addition of missing buttons
-----------------------------------
Two very important buttons were missing from the toolbar - Next Change (.uno:NextTrackedChange) and Previous Change (.uno:PreviousTrackedChange) - and Zeki suggested the addition of Compare Document (.uno:CompareDocuments) and Merge Document (.uno:MergeDocuments).

Step 2: Hiding of confusing buttons
-----------------------------------
There are two buttons labeled comment - one is a track change comment (.uno:CommentChangeTracking) and the second is the standard comment (.uno:InsertAnnotation). As the toolbar is for track changes, the standard comment should be hidden in this toolbar to eliminate confusion (also the standard comment will likely be coming to the standard toolbar - bug 83118).

Step 3: Set toolbar to 'Icons & Text'
-----------------------------------
A combination of icons and short labels are useful for this few entry floating toolbar. Possibly when new unique icons can be create for these buttons, maybe the labels wont be as important.

Step 4: Shortening text names
-----------------------------------
Here are single word text labels for the various multi word buttons

Protect - .uno:ProtectTraceChangeMode
Previous - .uno:PreviousTrackedChange
Next - .uno:NextTrackedChange
Accept - .uno:AcceptTracedChange
Reject - .uno:RejectTracedChange
Dialog - .uno:AcceptTrackedChanges
Compare - .uno:CompareDocuments
Merge - .uno:MergeDocuments

Step 5: Addition of uno icons
-----------------------------------
Until there are custom created buttons for these icons, here are useful icons i was able to get from the current uno icon set

.uno:ShowTrackedChanges - .uno:AddWatch
.uno:TrackChanges - .uno:RecSave
.uno:PreviousTrackedChange - .uno:ScrollToPrevious
.uno:NextTrackedChange - .uno:ScrollToNext
.uno:AcceptTracedChange - .uno:ZoomPlus
.uno:RejectTracedChange - .uno:ZoomMinus
.uno:ProtectTraceChangeMode - .uno:ChainFrames
.uno:CommentChangeTracking - .uno:EditDoc
.uno:AcceptTrackedChanges - .uno:InsertObjectFloatingFrame

-----------------------------------

I've included in the attached file, my modified xml toolbar file, as the buttons were reorganized to better suit the new buttons added. Compare and Merge Documents were left as hidden by default for users to enable if they so wish.
Comment 1 Yousuf Philips (jay) 2014-09-17 00:18:04 UTC
Created attachment 106397 [details]
modified changes toolbar

How the modified changes toolbar looks with the suggested small labels and icons (the icons arent clear due to a bug in libreoffice, that unfortunately still hasnt been fixed, when you add custom icons to buttons).
Comment 2 Joel Madero 2014-09-21 02:00:11 UTC
I think it look solid. Thanks for the work Jay
Comment 3 Yousuf Philips (jay) 2014-09-22 01:27:55 UTC
I put in the patches - https://gerrit.libreoffice.org/#/c/11575/

I hope that its is sufficient.
Comment 4 Commit Notification 2014-09-23 22:29:52 UTC
Yousuf Philips committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=bba15935842071289f6fbf9edef409b605254508

fdo#83955 Track Changes: Improve the changes toolbar



The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 5 Commit Notification 2014-09-24 08:40:28 UTC
Samuel Mehrbrodt committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=6332c643016ce4c4d254c8429a5eceae6664bf5c

fdo#83955 Fix changes toolbar to display icons+text



The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 6 Eyal Rozenberg 2014-09-24 11:12:36 UTC
Thank you so much for arranging this for us :-)
Comment 7 Yousuf Philips (jay) 2014-09-24 12:15:29 UTC
Hi Eyal,

Hope you can take some time to test it out and give us your thoughts.
Comment 8 Yousuf Philips (jay) 2014-09-27 08:07:06 UTC
Samuel: Unfortunately using 'toolbar:style="image text"' in the xml has a bad side effect, the user cant choose 'Icon Only' and 'Text Only' modes for the toolbar. :)
Comment 9 Eyal Rozenberg 2014-09-27 09:57:36 UTC
(In reply to comment #7)
Ok, some thoughts. Please do not take personal offense, I'm very appreciative of your work...

1. The 'Comment' button doesn't seem to work when I press it the first time; after that it's gray, basically regardless of what I do.
2. Why is there text besides the buttons on this toolbar when there is no such text on other toolbars? Now, I agree, a lot of the LibreOffice buttons have confusing icons, but that just means it might be reasonable to allow _all_ toolbars to have side-text for buttons.
3. The icons for accept change and reject change are the standard icons for 'zoom in' and 'zoom out'.
4. The tooltips do not explain what the buttons do.
5. 'More' should say something else, like, maybe, 'List' (or if we allow something longer tha 'Review Changes' or 'All Changes' etc.)
6. 'Previous Change' and 'Next Change' need button icons.
7. The record button icon looks like a 'save-and-play' icon. Perhaps an icon with something like two consecutive characters, the first black and the other colored and underlined, or the first struck-through and the second underlined, to illustrate a single change tracking? ... or maybe that would be better for the 'Show' button, and here it could be something like the current icn for 'comment', or the equivalent MS Word icon.
8. I don't get the 'protect' button icon.
9. I'm not really sure the 'Protect' button even belongs on this toolbar, as it doesn't much to do with tracked changes, reviewing etc.
Comment 10 Yousuf Philips (jay) 2014-09-27 12:03:24 UTC
Thanks Eyal for checking it out and for the feedback.

Here are responses to your thoughts.

1. If you select or within the text of a track change and press the 'comment' button, a dialog appears which allows you to enter in your comment.

2. Well the text next to the buttons were kept as the icons maybe confusing, as they are not custom icons.

3. Yes the accept and reject icons are the standard zoom in and out buttons, as unfortunately there isnt any other available icon that comes close enough to be suitable.

4. Yes the buttons do need better tooltips, but that would likely be in another bug report, as the scope of this bug report is to make sure the toolbar has all of the relevant buttons in it.

5. Yes i think 'List' or 'All Changes' might have been a better option for it.

6. Yes with the first nightly build, there werent any buttons for these two, but that has already been fixed since.

7. I picked the most suitable icon that is currently available in libreoffice's icon tango set.

8. The icon is of a chain, which is to symbolize locked.

9. The protect button is to password protect a document to preserve the current state that its in, likely a common thing to do after doing track changes.

I'm happy to say that within the last few days i began working on new icons for all the buttons, which you can see a preview of it at < https://redmine.documentfoundation.org/attachments/download/227/track%20changes%20icon%20set.png >. I'm hoping to finalize it the upcoming few days and then it will be pushed into new nightly builds.
Comment 11 Eyal Rozenberg 2014-09-27 13:41:43 UTC
(In reply to comment #10)
> Thanks Eyal for checking it out and for the feedback.
> 1. If you select or within the text of a track change and press the
> 'comment' button, a dialog appears which allows you to enter in your comment.
Why should I be able to comment only on a tracked change? ... Hmmm. Well, I dunno, maybe it makes some kind of sense. It's Not Like MS-Word (TM), though.

> 3. Yes the accept and reject icons are the standard zoom in and out buttons,
> as unfortunately there isnt any other available icon that comes close enough
> to be suitable.

Ah, why not? Just use a [✔] and a [✖] character from whatever font you like to make a bitmap. It's not perfect but it will do. And if the [✔] is blue or green, and the [✖] is red, it's even more clear. And if there's something which looks like a document in the background, probably even better.

> 7. I picked the most suitable icon that is currently available in
> libreoffice's icon tango set.

No way to add icons to that set?

> 8. The icon is of a chain, which is to symbolize locked.

I can't figure that out by looking at it. Isn't there some kind of a lock  icon, like one of, say, these:

http://findicons.com/search/lock

> 9. The protect button is to password protect a document to preserve the
> current state that its in, likely a common thing to do after doing track
> changes.

Really? I've never used these two in conjunction. I only use track changes to interact with someone who might make changes his/herself, never to show a changed document without others being able to edit it also.

> I'm happy to say that within the last few days i began working on new icons
> for all the buttons,

Just noticed that after writing everything else. They're quite nice, except for the accept/reject dialog, which is kind of ambiguous, but I can't think of a better alternative. Maybe if you could make the dialog there slightly bigger, and add a red and a green dot into it somehow to represent deletions and additions? I also think [✔] and [✖] are more apporpriate than [+] and [-].
Comment 12 Yousuf Philips (jay) 2014-09-27 15:21:09 UTC
(In reply to comment #11)
> Why should I be able to comment only on a tracked change? ... Hmmm. Well, I
> dunno, maybe it makes some kind of sense. It's Not Like MS-Word (TM), though.

There are two types of comments in libreoffice. One is the standard comment, which had the icon on it, which has been moved to the standard toolbar at the top, and the second is a tracked change comment, which allows you to add a comment to a tracked change. MS Word only has the standard comment option.

> Just noticed that after writing everything else. They're quite nice, except
> for the accept/reject dialog, which is kind of ambiguous, but I can't think
> of a better alternative. Maybe if you could make the dialog there slightly
> bigger, and add a red and a green dot into it somehow to represent deletions
> and additions? I also think [✔] and [✖] are more apporpriate than [+] and
> [-].

Yes the link was the first round of making the icons, and now the new set has [✔] and [✖] instead of the +/- < https://redmine.documentfoundation.org/attachments/download/228/add%20and%20del%20alternatives%20and%20new%20compare.png >. Will look into the dialog suggestion you made.
Comment 13 Eyal Rozenberg 2014-09-27 15:27:53 UTC
(In reply to comment #12)
> There are two types of comments in libreoffice. One is the standard comment,
> which had the icon on it, which has been moved to the standard toolbar at
> the top, and the second is a tracked change comment, which allows you to add
> a comment to a tracked change. MS Word only has the standard comment option.

I wonder if the second kind can't be renamed an 'explanation' rather than a comment. Anyway, note that it's easy to confuse the two.

> Yes the link was the first round of making the icons, and now the new set
> has [✔] and [✖] instead of the +/- <
> https://redmine.documentfoundation.org/attachments/download/228/
> add%20and%20del%20alternatives%20and%20new%20compare.png

I like alt_4 best. alt_1 is more clearly distinguishable at small sizes, but it reminds you too much of 'ok' and 'cancel' or 'error', which is not quite the right connotation. I wonder if the ✔ in alt4 can't be made even thicker at the thin end or overall. Also, I'd consider blue/purplish blue instead of green. (not sure about that).
Comment 14 Yousuf Philips (jay) 2014-09-27 22:06:57 UTC
(In reply to comment #13)
> I wonder if the second kind can't be renamed an 'explanation' rather than a
> comment. Anyway, note that it's easy to confuse the two.

Initially i didnt understand why there were 2 comment buttons in the changes toolbar, but it was soon clear why. :)

> I like alt_4 best. alt_1 is more clearly distinguishable at small sizes, but
> it reminds you too much of 'ok' and 'cancel' or 'error', which is not quite
> the right connotation. I wonder if the ✔ in alt4 can't be made even thicker
> at the thin end or overall. Also, I'd consider blue/purplish blue instead of
> green. (not sure about that).

Yes alt_4 is what i'm going with presently. I have made 2 more icons with blue and purplish blue as well as 2 more icons for slightly larger dialogs (adding the colors in it didnt work) that you can see at < https://redmine.documentfoundation.org/attachments/download/233/changes%20icons%202.png >.
Comment 15 Mike §chinagl 2014-12-20 21:33:09 UTC
This bug fix comes with LibreOffice 4.4 (release notes  https://wiki.documentfoundation.org/ReleaseNotes/4.4) 

Inclusion of new buttons in the Track Changes toolbar, along with a new set of icons.

See a graphic of the work:
https://wiki.documentfoundation.org/File:Changes_toolbar.png
Comment 16 Yousuf Philips (jay) 2015-02-12 20:15:27 UTC
As track change comment (.uno:CommentChangeTracking) is a feature only in ODF documents, it is important to also have the standard comment (.uno:InsertAnnotation) button also visible in the toolbar, so users dont have to jump between the standard toolbar and the track changes toolbar to add a comment.

https://gerrit.libreoffice.org/14450
Comment 17 Commit Notification 2015-02-13 09:59:56 UTC
Yousuf Philips committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=3743302fa26b0b3890b7113c30ec94755868a2f7

tdf#83955 enable insert comment and rearrange buttons

It will be available in 4.5.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.